unit uMain;

interface

uses
   System.SysUtils,
   System.Types,
   System.UITypes,
   System.Classes,
   System.Variants,
   System.Rtti,
   System.Bindings.Outputs,
   System.iOUtils,

   FMX.Types,
   FMX.Controls,
   FMX.Forms,
   FMX.Graphics,
   FMX.Dialogs,

   FMX.ListView.Types,
   FMX.ListView,
   FMX.ListBox,
   FMX.Layouts,
   FMX.Bind.Editors,
   FMX.Bind.DBEngExt,
   FMX.StdCtrls,

   Data.DB,
   Data.Bind.EngExt,
   Data.Bind.Components,
   Data.Bind.DBScope,
   Data.DbxSqlite,
   Data.SqlExpr,
   Data.FMTBcd;

type
   TfrmMain = class(TForm)
      ListBox1: TListBox;

      SQLConnection: TSQLConnection;

      SQLTable: TSQLTable;
      SQLTableEmployeeID: TLargeintField;
      SQLTableLastName: TWideStringField;
      SQLTableFirstName: TWideStringField;
      SQLTableTitle: TWideStringField;
      SQLTableTitleOfCourtesy: TWideStringField;
      SQLTableBirthDate: TWideMemoField;
      SQLTableHireDate: TWideMemoField;
      SQLTableAddress: TWideStringField;
      SQLTableCity: TWideStringField;
      SQLTableRegion: TWideStringField;
      SQLTablePostalCode: TWideStringField;
      SQLTableCountry: TWideStringField;
      SQLTableHomePhone: TWideStringField;
      SQLTableExtension: TWideStringField;
      SQLTablePhoto: TBlobField;
      SQLTableNotes: TWideMemoField;
      SQLTableReportsTo: TLargeintField;
      SQLTablePhotoPath: TWideStringField;
    BindSourceDB1: TBindSourceDB;
    BindingsList1: TBindingsList;
    LinkFillControlToField1: TLinkFillControlToField;
    ToolBar1: TToolBar;
    Label1: TLabel;
      procedure FormShow(Sender: TObject);
      procedure SQLConnectionBeforeConnect(Sender: TObject);
   private
      { Private declarations }
   public
      { Public declarations }
   end;

var
   frmMain: TfrmMain;

implementation

{$R *.fmx}

procedure TfrmMain.FormShow(Sender: TObject);
begin
   try
      SQLConnection.Open;
   except
      on E: Exception do
      begin
         ShowMessage(E.Message + #13#10 + E.ClassName);
      end;
   end;

   try
      SQLTable.Active := True;
   except
      on E: Exception do
      begin
         ShowMessage(E.Message + #13#10 + E.ClassName);
      end;
   end;
end;

procedure TfrmMain.SQLConnectionBeforeConnect(Sender: TObject);
var
   DBPath: string;
begin
   {$IF DEFINED(ANDROID)}
   DBPath := TPath.GetDocumentsPath + PathDelim + 'fddemo.sdb';
   SQLConnection.Params.Values['Database'] := DBPath;
   {$ENDIF}
end;

end.
